<template src="./template.html"></template>

<script lang="ts">
import {
  Component,
  getModule,
  Prop,
  Vue,
  Watch,
} from "nuxt-property-decorator";
import { api } from "~/common/constaint";
import UserModule from "~/store/user";
import { redirectPage } from "~/utils/apiHanlers";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({})
export default class DuplicateStoreComponent extends Vue {
  productList = [];
  config = {
    page: 1,
    limit: 24,
    search: "",
  };
  domains = [];
  createStore: any = {};
  subDomain = "";

  domain: any = {};

  loading = false;

  async onSelectDomain(domain: any) {
    await this.onCheckDomain();
    const findDomain = this.domains.find(
      (itemCheckDomain: any) => itemCheckDomain.domain === domain
    );
    if (findDomain) {
      this.domain = findDomain;
    } else {
      this.domain = {};
    }
  }

  isDomainExist = false;
  isDomainNotExist = false;
  loadingCheckDomain = false;

  async onCheckDomain() {
    try {
      this.isDomainExist = false;
      this.isDomainNotExist = false;

      if (!this.createStore.store.slug || !this.subDomain) return;
      this.loadingCheckDomain = true;
      await this.$api.store.sellerStoreCheckDomain({
        domain: this.createStore.store.slug + "." + this.subDomain,
      });
      this.isDomainNotExist = true;
    } catch (error) {
      this.isDomainExist = true;
      // apiErrorHandler(error, this);
    } finally {
      this.loadingCheckDomain = false;
    }
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  async onGetDomain() {
    try {
      let query = {
        ...this.config,
      };
      const res = await this.$api.domainSeller.list(query);
      if (res?.data) {
        this.domains = res?.data?.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }

  isErrorDomainName = false;

  backToStore() {
    this.$router.push("/seller/store");
  }

  async onCreateStore() {
    try {
      this.isErrorDomainName = false;
      if (!this.createStore.store.storeName) {
        return this.$pushNotification.error("Please fill store name field");
      }
      if (!this.createStore.store.domain) {
        return this.$pushNotification.error("Please fill store domain field");
      }

      if (this.createStore.store.domain.length > 63) {
        this.isErrorDomainName = true;
        return this.$pushNotification.error(
          "Domain cannot be more than 63 characters"
        );
      }
      if (!this.subDomain) {
        return this.$pushNotification.error("Please choose subdomain");
      }
      const body = {
        storeName: this.createStore.store.storeName,
        domain: this.createStore.store.slug + "." + this.subDomain,
        domainId: this.domain._id,
        slug: this.createStore.store.slug,
        productId: this.createStore.product.productId._id || "",
        supportEmail: this.domain.supportEmail,
      };
      this.loading = true;
      await this.$api.store.create(body);
      this.$pushNotification.success("Create store success");

      this.$router.push("/seller/store");
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }
  storeId = "";

  mounted() {
    this.storeId = this.$route.params.slug || "";
    this.onGetDetailStore();
    this.onGetDomain();
  }

  async onGetDetailStore() {
    try {
      const res = await this.$api.store.detail(this.storeId);
      if (res?.data) {
        this.createStore = res.data;
      }
    } catch (error) {
      apiErrorHandler(error, this);
    }
  }
  @Watch("createStore.store.domain")
  changedValue(value: string) {
    if (value.length > 63) {
      this.isErrorDomainName = true;
    } else {
      this.isErrorDomainName = false;
    }
  }
}
</script>

<style src="./style.scss" lang="scss" scoped></style>
<style lang="scss" scoped>
.name-input {
  max-width: 237px;
  width: 100%;
  background: white;
  border-radius: 6px;

  @media (max-width: 640px) {
    max-width: 100%;
    margin-bottom: 8px;
  }
}

.number-input {
  max-width: 132px;
  width: 100%;
  background: white;
  border-radius: 6px;

  @media (max-width: 640px) {
    max-width: 98%;
  }
}
</style>
